/*
 * Copyright (C) 2023 Red Hat
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include <glib-object.h>

#include "backends/native/meta-backend-native.h"

#define META_TYPE_KMS_LEASE (meta_kms_lease_get_type ())
G_DECLARE_FINAL_TYPE (MetaKmsLease, meta_kms_lease,
                      META, KMS_LEASE, GObject)

#define META_TYPE_KMS_LEASE_MANAGER (meta_kms_lease_manager_get_type ())
G_DECLARE_FINAL_TYPE (MetaKmsLeaseManager, meta_kms_lease_manager,
                      META, KMS_LEASE_MANAGER, GObject)

uint32_t meta_kms_lease_get_id (MetaKmsLease *lease);

int meta_kms_lease_steal_fd (MetaKmsLease *lease);

gboolean meta_kms_lease_is_active (MetaKmsLease *lease);

void meta_kms_lease_revoke (MetaKmsLease *lease);

MetaKmsLease * meta_kms_lease_manager_lease_connectors (MetaKmsLeaseManager  *lease_manager,
                                                        GList                *connectors,
                                                        GError              **error);

GList * meta_kms_lease_manager_get_connectors (MetaKmsLeaseManager *lease_manager);

MetaKmsConnector * meta_kms_lease_manager_get_connector_from_id (MetaKmsLeaseManager *lease_manager,
                                                                 uint32_t             connector_id);

MetaKmsLease * meta_kms_lease_manager_get_lease_from_connector (MetaKmsLeaseManager *lease_manager,
                                                                MetaKmsConnector    *kms_connector);

MetaKmsLease * meta_kms_lease_manager_get_lease_from_id (MetaKmsLeaseManager *lease_manager,
                                                         uint32_t             lessee_id);
